<template>
  <div
    class="page-table scrollable only-y"
    id="affix-container"
  >
    <div class="">
      <h1>Employer
        <!--<span v-if="!loading" class="lbl-verify">-->
        <!--<label v-if="detail.isVerified" class="lbl lbl-success">Verified</label>-->
        <!--<label v-else class="lbl label-default">Unverified</label>-->
        <!--</span>-->
      </h1>
      <!--<h4>for a better experience on Mac OS during horizontal scroll is prefered disable the "Swipe between pages" option </h4>-->
      <div class="page-status">

        <el-breadcrumb separator="/">
          <el-breadcrumb-item :to="{ path: '/' }"><i class="mdi mdi-home-outline"></i></el-breadcrumb-item>

          <el-breadcrumb-item :to="{ path: '/employers' }">Employers</el-breadcrumb-item>

          <el-breadcrumb-item :to="{ path: '/employers/' + $route.params.id }">{{employerName.length < 50 ? employerName : employerName.substring(0,50)+'...'}}</el-breadcrumb-item>

          <el-breadcrumb-item>Edit</el-breadcrumb-item>
          <!--<div v-if="detail.status" class="verified-item">-->
          <!--<span class="lbl lbl-info"> {{$helper.replaceUnderscore(detail.status)}}</span>-->
          <!--</div>-->

        </el-breadcrumb>
        <div
          v-if="!loading"
          class="content-status verified-item"
        >
          <span
            v-if="detail.isVerified"
            class="lbl lbl-success"
          >Verified</span>
          <span
            v-else
            class="lbl label-default"
          >Unverified</span>
        </div>
      </div>
    </div>
    <br />
    <el-card
      v-if="isContentFound"
      v-loading="loading"
    >
      <not-found></not-found>
    </el-card>
    <div v-else>
      <el-card
        class="box-card"
        v-loading="loading"
      >
        <div
          class="card-inner"
          v-if="detail"
        >
          <div class="line">
            <div class="">
              <el-row :gutter="5">
                <!-- Start col upload image -->
                <el-col
                  :xs="24"
                  :sm="12"
                  :md="8"
                >
                  <el-upload
                    :auto-upload="false"
                    class="avatar-uploader companyCover"
                    action="https://jsonplaceholder.typicode.com/posts/"
                    :show-file-list="false"
                    drag
                    :disabled="false"
                    :on-change="onChangeIconHandle"
                  >

                    <div
                      v-if="detail.cover"
                      style="height: 100%; width: 100%; display: flex"
                    >
                      <img
                        :src="detail.cover"
                        class="avatar"
                      >
                      <!-- <el-button
                        width=32
                        height=32
                        @click="onRemoveImg"
                        class="icon-img-close-employer"
                        icon="el-icon-close"
                        type="info"
                        circle
                        mini
                        plain
                      ></el-button> -->
                    </div>
                    <i
                      v-else
                      class="el-icon-plus avatar-uploader-icon"
                    ></i>
                  </el-upload>
                </el-col>
                <!-- End col upload image -->

              </el-row>

            </div>
          </div>
          <el-card
            shadow="never"
            class="box-card"
            style="margin-top: 20px"
          >
            <el-form
              :model="detail"
              :rules="rules"
              ref="detail"
            >
              <el-row :gutter="30">
                <el-col
                  :span="12"
                  :md="12"
                  :sm="24"
                  :xs="24"
                  class="col-p"
                >
                  <el-form-item
                    label="Full Name"
                    prop="full_name"
                  >
                    <el-input v-model="detail.full_name" />
                  </el-form-item>
                </el-col>
                <el-col
                  :span="12"
                  :md="12"
                  :sm="24"
                  :xs="24"
                  class="col-p"
                >
                  <el-form-item
                    label="Phone number"
                    prop="phone_number"
                  >
                    <!--<el-input  type="text" v-model="address" @focus="openDialog"/>-->
                    <el-input
                      disabled
                      type="text"
                      prop="phone_number"
                      v-model="detail.phone_number"
                    />
                  </el-form-item>
                </el-col>
              </el-row>

              <!-- Start Email  -->
              <el-row :gutter="30">
                <el-col
                  :span="12"
                  :md="12"
                  :sm="24"
                  :xs="24"
                  class="col-p"
                >
                  <el-form-item
                    label="Email"
                    type="Email"
                    prop="email"
                  >
                    <el-input
                      v-model="detail.email"
                      disabled
                    ></el-input>
                  </el-form-item>
                </el-col>
                <!-- <el-col
                  :span="12"
                  :md="12"
                  :sm="24"
                  :xs="24"
                  class="col-p"
                > -->

                <!-- </el-col> -->
              </el-row>
              <el-row class="flex justify-end">
                <el-button
                  icon="mdi mdi-content-save-outline"
                  type="primary"
                  @click="save"
                > Save changes</el-button>
              </el-row>
              <div>
              </div>
            </el-form>
          </el-card>
        </div>
      </el-card>

    </div>

  </div>
</template>

<script>
export default {

}
</script>
<script>
import helper from '~/services/helper'
import { employer as employerAPI, media as mediaAPI } from '~/services/apis/index'
import NotFound from '../ContentNotFound'
export default {
  name: 'EmployerEdit',
  components: {
    NotFound,
  },
  data () {
    return {
      detail: {
        id: '',
        full_name: '',
        email: '',
        created_at: "",
        verified_at: "",
        icon_url: "",
        address: "",
        latitude: "",
        longitude: "",
        phone_number: "",
        phone_number_verified_at: "",
        location: {
          lat: 0,
          lng: 0
        },
        cover: "",
        employerName: "",
        imageName: "",
        updateIcon: false,
        file: null,
      },

      loading: true,
      listImage: [
        {
          src: "",
          file: null
        },
      ],
      imageIndex: "",
      file: '',
      mapvisible: false,
      dialogvisible: false,
      imageUrl: null,
      address: "",

      backToEmployers: false,
      employerName: "",
      backID: "",
      isContentFound: false,
      isDisabledVerify: false,
      isDisabledSave: false,

      rules: {
        full_name: [
          { required: true, message: 'Please input  name', trigger: 'blur' },
          { max: 255, message: 'Length must be less than 256', trigger: 'blur' }
        ],
        email: [{ required: true, message: 'Please input email', trigger: 'blur' }]

      },

    }
  },
  methods: {
    getDetail () {
      if (!this.$route || !this.$route.params.id) return;
      employerAPI.getEmployer(this.$route.params.id)
        .then((res) => {
          this.initDetail(res.data.data);
          this.isContentFound = false;
          this.loading = false;
        })
        .catch((err) => {
          this.isContentFound = true;
          this.loading = false;
        })
    },

    initDetail (data) {
      if (!data) return;

      this.detail.id = data.id;
      this.detail.full_name = this.employerName = data.user.full_name;
      this.detail.email = data.user.email;
      this.detail.phone_number = data.user.phone_number;
      this.detail.isVerified = data.user.phone_number_verified_at ? true : false;

      if (data.user && data.user.avatar_url)
        this.detail.cover = data.user.avatar_url;



      this.listImage[0].src = this.detail.cover;
    },
    onChangePage (page) {
      this.currentPage = this.$helper.formatPage(page)
      //this.$router.push({query: {page: page}})
      this.getListPost();
    },
    formatSalary (from, to) {
      if (!from && !to) {
        return ""
      }
      return "from " + from + " to " + to;
    },

    openDialog () {
      this.mapvisible = true
    },

    updateStatus (value) {
      this.isDisabledVerify = true;

      employerAPI.verify(this.detail.id, value)
        .then(res => {
          if (res.status === 200) {
            this.$notify({
              title: "Success",
              message: "Update  successfully!",
              type: "success"
            });
            this.detail.isVerified = value;
            this.isDisabledVerify = false;
          }
        })
        .catch(err => {
          this.$notify({
            title: "Error",
            message: "Update failed!",
            type: "error"
          });
          this.isDisabledVerify = false;
        });
    },
    showAvatar (url, event) {
      if (event) {
        event.preventDefault();
        event.stopPropagation();
      }

      if (!url) return;
      this.imageUrl = url;
      this.dialogvisible = true;
    },
    save () {
      this.loading = true;
      this.$refs['detail'].validate((valid) => {
        if (valid) {
          this.submit();
        } else {
          this.loading = false;
          return false;
        }
      });

    },
    submit () {
      this.loading = true;
      if (this.file) {
        mediaAPI.upload(this.file)
          .then(res => {
            if (res.data.success) {
              let avatar_path = res.data.data.path;
              let full_name = this.detail.full_name;
              let data = {
                user: {
                  full_name,
                  avatar_path
                }
              };
              console.log('data :', data);
              this.updateEmployer(data);
            }
          })
          .catch(err => {
            this.$notify({
              title: "Error",
              message: "Update failed!",
              type: "error"
            });
            this.loading = false;
          })
      } else {
        let full_name = this.detail.full_name;
        let data = {
          user: {
            full_name,
          }
        };
        employerAPI.updateEmployer(this.$route.params.id, data)
          .then((res) => {
            this.$notify({
              title: "Success",
              message: "Update successfully!",
              type: "success"
            });
            this.loading = false;
            this.$router.push({ name: 'employers_detail' });
          })
          .catch((err) => {
            this.$notify({
              title: "Error",
              message: "Please include your first name and last name when entering your full name",
              type: "error"
            });
            this.loading = false;
          })
      }
    },

    updateEmployer (data) {
      employerAPI.updateEmployer(this.$route.params.id, data)
        .then((res) => {
          this.$notify({
            title: "Success",
            message: "Update successfully!",
            type: "success"
          });
          this.loading = false;
          this.$router.push({ name: 'employers_detail' });
        })
        .catch((err) => {
          this.$notify({
            title: "Error",
            message: "Update failed!",
            type: "error"
          });
          this.loading = false;
        })
    },
    onChangeIconHandle (file, fileList) {
      if (!file) return;

      this.imageName = file.name;
      this.detail.cover = URL.createObjectURL(file.raw);
      this.file = file.raw;
      this.updateIcon = true;
      this.uploadImage(this.file);
    },
    /* Upload image */
    uploadImage (data) {
      this.loading = true;
      if (data) {
        mediaAPI.upload(data).then(res => {
          if (res.data.success) {
            let image = {
              path: res.data.data.path
            }
            const data = {
              user: {
                avatar_path: res.data.data.path,
              },
            };
            employerAPI.updateEmployer(this.$route.params.id, data)
              .then((res) => {
                this.$notify({
                  title: "Success",
                  message: "Update image successfully!",
                  type: "success"
                });
                this.loading = false;
              })
              .catch((err) => {
                this.$notify({
                  title: "Error",
                  message: "Update image failed!",
                  type: "error"
                });
                this.loading = false;
              })
          }
        });
      }
    },
    onRemoveImg (e) {
      e.preventDefault();
      e.stopPropagation();
      this.removeImg();
    },
    removeImg () {
      this.imageName = "";
      this.file = null;
      this.updateIcon = true;
      this.detail.cover = "";
    },

  },

  mounted () {
    // if(this.$route.query && this.$route.query.back == 'employers' && this.$route.query.back_id ){
    //     this.backToEmployers = true;
    //     this.backID = this.$route.query.back_id;
    //     this.employerName = this.$route.query.employer_name;
    // }
    this.getDetail();
    // this.getListPost();


  }
}
</script>
<style lang="scss" scope>
.icon-img-close-employer {
  position: absolute;
  top: 3px;
  right: 5px;
  padding: 3px !important;
}
.justify-end {
  justify-content: flex-end;
}
</style>
